#include <iostream>
using namespace std;

int main(){

    int t,n,m,a,f=0,k=1;
    cin>>t;
    int c[n];
    int g[n];
    int b[t];
    int matl[n][m];
    int matu[n][m];
    for(a=0;a<t;a++){
        cin>>n>>m;
        for(int i=0;i<n;i++){
            c[i]=1;
            g[i]=-1;
        }
        for(int i = 0; i < n; i++){
            for(int j = 0; j < m; j++){
                cin>>matl[i][j];
                if(matl[i][k]<=0){
                c[a]=matl[i][k];
            }
            }
        }
        for(int i = 0; i < n; i++){
            for(int j = 0; j < m; j++){
                cin>>matu[i][j];
                if(matl[i][f]>=0){
                g[a]=matl[i][f];
            }
        }
        }
        if(g[a]>=0&&c[a]<=0){
            b[a]=1;
        }else{
            b[a]=0;
        }
    }

    for(int a=0;a<t;a++){
        if(b[a]==0){
            cout<<"DA"<<endl;
            for(int i=0;i<n;i++){
                cout<<g[a]<<c[a]<<endl;
            }

        }else{
            cout<<"NE"<<endl;


        }
    }


  return 0;

  }